import React, { useState, useEffect } from 'react'
import fetch from 'unfetch'

import LoadingIndicator from '../components/LoadingIndicator.js'
import QuestionSearchResult from '../components/QuestionSearchResult.js'

import constants from '../constants.json'

export default function AllQuestions (props) {
  const [data, setData] = useState(null)
  const [searchTerm, setSearchTerm] = useState('')

  useEffect(() => {
    fetch(`${constants.apiUrl}data.json`)
      .then((resp) => {
        return resp.json()
      })
      .then((data) => {
        setData(data)
      })
  }, [])

  if (data) {
    return (
      <div>
        <div>
          <input
            placeholder='Keresés...'
            className='searchBar'
            type='text'
            value={searchTerm}
            onChange={(e) => { setSearchTerm(e.target.value) }}
          />
        </div>
        <hr />
        <div>
          <QuestionSearchResult
            data={data}
            searchTerm={searchTerm}
          />
        </div>
      </div>
    )
  } else {
    return (
      <LoadingIndicator />
    )
  }
}
